import java.util.Arrays;

/* Task2: no slicing, no bullshit memcopy, parralelized merge */
public class Task2 {

  /* Create new sorted array by merging 2 smaller sorted arrays */
  private static void merge(int[] src, int[] dst, int idx1, int idx2, int end) {
		int mid  = idx2;
		int idx3 = idx1;
		while (idx1 < mid && idx2 < end) {
			if (src[idx1] < src[idx2])
        dst[idx3++] = src[idx1++];
			else
        dst[idx3++] = src[idx2++];
		}
		while (idx1 < mid) dst[idx3++] = src[idx1++];
		while (idx2 < end) dst[idx3++] = src[idx2++];
	}

  /* Recursive core, calls a sibling thread until max depth is reached */
  public static boolean kernel(int[] src, int[] dst, int start, int end) {

    /* Check if max depth has been reached */
    int tnum = Runtime.getRuntime().availableProcessors();
    boolean isLeaf = src.length / (end - start) > tnum;

    /* Single thread sort if bottom has been reached or array is very small */
    if (isLeaf || end - start < 1000) {
      Arrays.sort(src, start, end);
      return false;
    }

    /* Otherwise split task into two recursively */
    else {
      int mid = (start + end) / 2;
      Thread sibling = new Thread(() -> kernel(src, dst, mid, end));
      sibling.start();
      boolean isInverted = kernel(src, dst, start, mid);
      try {sibling.join();}
      catch (InterruptedException ie) {ie.printStackTrace();}
      if (isInverted)
        merge(dst, src, start, mid, end);
      else
        merge(src, dst, start, mid, end);
      return !isInverted;
    }

  }

  /* Creates a sorted version of any int array */
  public static int[] sort(int[] array) {

    /* Initialize variables */
    int[] src = array.clone();
    int[] dst = new int[array.length];

    /* Launch recursive core */
    boolean isInverted = kernel(src, dst, 0, src.length);

    return isInverted ? dst : src;

  }
}
